#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

const int MAX_N = 1e6 + 42;
const int INF = 1e9;
const int mod = 1e9 + 7;

int a[MAX_N];
int dp[MAX_N];

int main () {

    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL);

    int s, n;
    std::cin>>s>>n;

    for( int i=0 ; i<n ; i++ ){
        std::cin>>a[i];
        dp[a[i]] = 1;
    }


    for( int i=2 ; i<=s ; i++ ){
        if( !dp[i] ) dp[i] = INF;
        for( int j=0 ; j<n ; j++ ){
            if( i-a[j] > 0 )
                dp[i] = std::min( dp[i], dp[i-a[j]] +1 );
        }
    }

    std::cout<<dp[s]<<"\n";

    return 0;
}
